* ------------------------------------------------------ *
* SISTEMA     : INFO-Farma                               *
* PRG         : CARDARTI.PRG                             *
* CREADO      : 25-06-2006                               *
* ACTUALIZADO :                                          *
* AUTOR       : EDUARDO V. FLORES RIVAS                  *
* COMENTARIOS :                                          *
* ------------------------------------------------------ *

FUNC CardArti
PARA cQueArti

   IF IsWindowDefined(Win_FichaArti)=.T.
      MINIMIZE WINDOW Win_FichaArti
      RESTORE WINDOW Win_FichaArti
      RETURN
   ENDIF

PRIVATE lSaved  := .F.
PRIVATE KA_MODO := ''

   DEFINE WINDOW Win_FichaArti ;
      AT 0,0 ;
      WIDTH 700 ;
      HEIGHT 500 ;
      TITLE 'Administrador de Artculos' ;
      MODAL ;
      ON INIT CardArti_Iniciar() ;
      FONT 'ARIAL' SIZE 9

      ON KEY ESCAPE OF Win_FichaArti ACTION CardArti_Salir()
      
      ON KEY F1     OF Win_FichaArti ACTION CardArti_Consultar()
      ON KEY F2     OF Win_FichaArti ACTION CardArti_Crear()
      ON KEY F3     OF Win_FichaArti ACTION CardArti_Editar()
      ON KEY F4     OF Win_FichaArti ACTION CardArti_Grabar()
      ON KEY F5     OF Win_FichaArti ACTION CardArti_Borrar()

//
//         TOOLBAR
//
      DEFINE TOOLBAR ToolBar_1 BUTTONSIZE 70,30 FLAT BORDER

         BUTTON BtnBuscar ;
            CAPTION '[F1] &Buscar' ;
            PICTURE 'imagen\prismaazul.bmp'   ;
            ACTION CardArti_Consultar()

         BUTTON BtnNuevo ;
            CAPTION '[F2] &Nuevo' ;
            PICTURE 'imagen\agregar.bmp' ;
            ACTION CardArti_Crear()

         BUTTON BtnEditar ;
            CAPTION '[F3] &Editar' ;
            PICTURE 'imagen\editar.bmp' ;
            ACTION CardArti_Editar()

         BUTTON BtnGrabar ;
            CAPTION '[F4] &Grabar' ;
            PICTURE 'imagen\grabar.bmp' ;
            ACTION CardArti_Grabar()

         BUTTON BtnBorrar ;
            CAPTION '[F5] &Borrar' ;
            PICTURE 'imagen\borrar.bmp' ;
            ACTION CardArti_Borrar()

         BUTTON BtnSalir ;
            CAPTION '[Esc] &Salir' ;
            PICTURE 'imagen\salir.bmp' ;
            ACTION CardArti_Salir()

      END TOOLBAR
//
//
//
      @ 060 , 010 LABEL LblCodArti ;
         VALUE 'Cdigo:' ;
         WIDTH 70 ;
         FONTCOLOR Color_Label3_Font ;
         BACKCOLOR Color_Label3_Back ;
         RIGHTALIGN

      @ 060 , 090 TEXTBOX TxtCodArti ;
         WIDTH 80 ;
         READONLY ;
         NOTABSTOP

      @ 060 , 200 BUTTON BtnTipo ;
         CAPTION 'Tipo:' ;
         ACTION CardArti_SetTipo() ;
         WIDTH  70 ;
         HEIGHT 25

      @ 060 , 280 TEXTBOX TxtCodTipo ;
         WIDTH 070 ;
         READONLY ;
         NOTABSTOP

      @ 060 , 360 TEXTBOX TxtNomTipo ;
         WIDTH 250 ;
         READONLY ;
         NOTABSTOP
//
//
//
      @ 090 , 010 BUTTON BtnDisa ;
         CAPTION 'DISA:' ;
         ACTION CardArti_SetDisa() ;
         WIDTH 75 ;
         HEIGHT 25

      @ 090 , 090 TEXTBOX TxtCodDisa ;
         WIDTH 070 ;
         READONLY ;
         NUMERIC INPUTMASK '999999' ;
         NOTABSTOP

      @ 090 , 170 TEXTBOX TxtNomDisa ;
         WIDTH 380 ;
         READONLY ;
         NOTABSTOP
//
//
//
      @ 120 , 010 LABEL LblDesArti ;
         VALUE 'Artculo:' ;
         WIDTH 70 ;
         FONTCOLOR Color_Label3_Font ;
         BACKCOLOR Color_Label3_Back ;
         RIGHTALIGN

      @ 120 , 090 TEXTBOX TxtDesArti ;
         MAXLENGTH 50 ;
         WIDTH 460 ;
         UPPERCASE ;
         ON ENTER Win_FichaArti.BtnMarca.SetFocus()
//
//
//
      @ 150 , 010 BUTTON BtnMarca ;
         CAPTION 'Marca:' ;
         ACTION CardArti_SetMark() ;
         WIDTH 75 ;
         HEIGHT 25

      @ 150 , 090 TEXTBOX TxtCodMarca ;
         WIDTH 70 ;
         READONLY ;
         NOTABSTOP

      @ 150 , 170 TEXTBOX TxtDesMarca ;
         WIDTH 380 ;
         READONLY ;
         NOTABSTOP
//
//
//
      @ 180 , 010 BUTTON BtnGene ;
         CAPTION 'Gnero:' ;
         ACTION CardArti_SetGene() ;
         WIDTH 75 ;
         HEIGHT 25

      @ 180 , 090 TEXTBOX TxtCodGene ;
         WIDTH 70 ;
         READONLY ;
         NOTABSTOP

      @ 180 , 170 TEXTBOX TxtDesGene ;
         WIDTH 380 ;
         READONLY ;
         NOTABSTOP
//
//
//
      @ 210 , 010 LABEL LblBarra ;
         VALUE 'Cod.Barra:' ;
         WIDTH 70 ;
         FONTCOLOR Color_Label3_Font ;
         BACKCOLOR Color_Label3_Back ;
         RIGHTALIGN

      @ 210 , 090 TEXTBOX TxtCodBarr ;
         WIDTH 200 ;
         ON ENTER Win_FichaArti.TxtFracciones.Setfocus()
//
//
//
      @ 240 , 010 LABEL LblFracciones ;
         VALUE 'Fracciones:' ;
         WIDTH 70 ;
         FONTCOLOR Color_Label3_Font ;
         BACKCOLOR Color_Label3_Back ;
         RIGHTALIGN

      @ 240 , 090 TEXTBOX TxtFracciones ;
         WIDTH 100 ;
         NUMERIC INPUTMASK '9999' ;
         ON ENTER Win_FichaArti.CmbIGV.Setfocus() ;
         ON LOSTFOCUS CardArti_SetFracs()

      @ 240 , 220 LABEL LblIGV ;
         VALUE 'I.G.V.:' ;
         WIDTH 70 ;
         FONTCOLOR Color_Label3_Font ;
         BACKCOLOR Color_Label3_Back ;
         RIGHTALIGN

      @ 240 , 300 COMBOBOX CmbIGV ;
         ITEMS SYS_SINO ;
         WIDTH 50 ;
         ON ENTER Win_FichaArti.TxtPrecioU.SetFocus() ;
         ON CHANGE Win_FichaArti.TxtPrecioU.SetFocus()

      @ 240 , 380 LABEL LblIncentivo ;
         VALUE 'Incentivo:' ;
         ACTION Win_FichaArti.TxtIncentivo.Setfocus() ;
         WIDTH 70 ;
         FONTCOLOR Color_Label3_Font ;
         BACKCOLOR Color_Label3_Back ;
         RIGHTALIGN

      @ 240 , 460 TEXTBOX TxtIncentivo ;
         WIDTH 100;
         NUMERIC INPUTMASK '99999.99'
//
//
//
      @ 270 , 090 LABEL LblUni ;
         VALUE 'UNIDS.:' ;
         WIDTH 100 ;
         FONTCOLOR Color_Label1_Font ;
         BACKCOLOR Color_Label1_Back ;
         CENTERALIGN

      @ 270 , 200 LABEL LblFra ;
         VALUE 'FRACS.:' ;
         WIDTH 100 ;
         FONTCOLOR Color_Label1_Font ;
         BACKCOLOR Color_Label1_Back ;
         CENTERALIGN
//
//
//
      @ 300 , 010 LABEL LblReal ;
         VALUE 'COSTO:' ;
         WIDTH 70 ;
         FONTCOLOR Color_Label3_Font ;
         BACKCOLOR Color_Label3_Back ;
         RIGHTALIGN

      @ 300 , 090 TEXTBOX TxtCostoU ;
         READONLY ;
         WIDTH 100;
         NUMERIC ;
         INPUTMASK '99999.99'

      @ 300 , 200 TEXTBOX TxtCostoF ;
         READONLY ;
         WIDTH 100;
         NUMERIC INPUTMASK '99999.99'
//
//
//
      @ 330 , 010 LABEL LblUtilidad ;
         VALUE '% UTILID.:' ;
         WIDTH 70 ;
         FONTCOLOR Color_Label3_Font ;
         BACKCOLOR Color_Label3_Back ;
         RIGHTALIGN

      @ 330 , 090 TEXTBOX TxtUtilU ;
         WIDTH 100;
         NUMERIC ;
         INPUTMASK '999.99' ;
         ON ENTER IF( Win_FichaArti.TxtFracciones.Value>1 , Win_FichaArti.TxtUtilF.SetFocus() , Win_FichaArti.Aceptar.SetFocus() )

      @ 330 , 200 TEXTBOX TxtUtilF ;
         WIDTH 100;
         NUMERIC ;
         INPUTMASK '999.99' ;
         ON ENTER Win_FichaArti.Aceptar.SetFocus()
//
//
//
      @ 360 , 010 LABEL LblPrecioU ;
         VALUE 'PRECIO:' ;
         WIDTH 70 ;
         FONTCOLOR Color_Label3_Font ;
         BACKCOLOR Color_Label3_Back ;
         RIGHTALIGN

      @ 360 , 090 TEXTBOX TxtPrecioU ;
         WIDTH 100;
         NUMERIC ;
         INPUTMASK '99999.99' ;
         ON ENTER ( IF( Win_FichaArti.TxtFracciones.Value>1 , Win_FichaArti.TxtPrecioF.SetFocus() , Win_FichaArti.BtnGrabar.SetFocus() ) )

      @ 360 , 200 TEXTBOX TxtPrecioF ;
         WIDTH 100;
         NUMERIC ;
         INPUTMASK '99999.99' ;
         ON ENTER Win_FichaArti.BtnGrabar.SetFocus()
//
//
//
      @ 390 , 010 LABEL LblStocks ;
         VALUE 'STOCKS:' ;
         WIDTH 70 ;
         FONTCOLOR Color_Label3_Font ;
         BACKCOLOR Color_Label3_Back ;
         RIGHTALIGN

      @ 390 , 090 TEXTBOX TxtStockU ;
         WIDTH 100;
         READONLY ;
         NUMERIC ;
         INPUTMASK '9999999'

      @ 390 , 200 TEXTBOX TxtStockF ;
         WIDTH 100;
         READONLY ;
         NUMERIC ;
         INPUTMASK '9999999' ;

   END WINDOW

   CENTER WINDOW Win_FichaArti
   ACTIVATE WINDOW Win_FichaArti

RETURN( lSaved )


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC CardArti_Iniciar

   KA_MODO := ''

   Win_FichaArti.BtnNuevo.Enabled      := .T.
   Win_FichaArti.BtnEditar.Enabled     := .F.
   Win_FichaArti.BtnGrabar.Enabled     := .F.
   Win_FichaArti.BtnBorrar.Enabled     := .F.

   Win_FichaArti.BtnTipo.Enabled       := .F.
   Win_FichaArti.BtnDisa.Enabled       := .F.
   Win_FichaArti.BtnMarca.Enabled      := .F.
   Win_FichaArti.BtnGene.Enabled       := .F.

   Win_FichaArti.TxtDesArti.ReadOnly   := .T.
   Win_FichaArti.TxtCodBarr.ReadOnly   := .T.
   Win_FichaArti.TxtFracciones.ReadOnly:= .T.
   Win_FichaArti.CmbIgv.ReadOnly       := .T.
   Win_FichaArti.TxtIncentivo.ReadOnly := .T.
   Win_FichaArti.TxtUtilU.ReadOnly     := .T.
   Win_FichaArti.TxtUtilF.ReadOnly     := .T.
   Win_FichaArti.TxtPrecioU.ReadOnly   := .T.
   Win_FichaArti.TxtPrecioF.ReadOnly   := .T.

   Win_FichaArti.TxtCodTipo.Value    := SPACE(4)
   Win_FichaArti.TxtNomTipo.Value    := SPACE(40)
   Win_FichaArti.TxtCodDisa.Value    := 0
   Win_FichaArti.TxtNomDisa.Value    := SPACE(80)
   Win_FichaArti.TxtCodArti.Value    := SPACE(6)
   Win_FichaArti.TxtDesArti.Value    := SPACE(50)
   Win_FichaArti.TxtCodMarca.Value   := SPACE(6)
   Win_FichaArti.TxtDesMarca.Value   := SPACE(50)
   Win_FichaArti.TxtCodGene.Value    := SPACE(6)
   Win_FichaArti.TxtDesGene.Value    := SPACE(60)
   Win_FichaArti.TxtCodBarr.Value    := SPACE(20)
   Win_FichaArti.TxtFracciones.Value := 0
   Win_FichaArti.CmbIgv.Value        := 0
   Win_FichaArti.TxtIncentivo.Value  := 0.00
   Win_FichaArti.TxtCostoU.Value     := 0.00
   Win_FichaArti.TxtCostoF.Value     := 0.00
   Win_FichaArti.TxtUtilU.Value      := 0.00
   Win_FichaArti.TxtUtilF.Value      := 0.00
   Win_FichaArti.TxtPrecioU.Value    := 0.00
   Win_FichaArti.TxtPrecioF.Value    := 0.00
   Win_FichaArti.TxtStockU.Value     := 0
   Win_FichaArti.TxtStockF.Value     := 0

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC CardArti_Salir

   RELEASE WINDOW Win_FichaArti

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC CardArti_Crear

   CardArti_Iniciar()
   KA_MODO := 'CREAR'
   Win_FichaArti.BtnNuevo.Enabled   := .T.
   Win_FichaArti.BtnEditar.Enabled  := .F.
   Win_FichaArti.BtnGrabar.Enabled  := .T.
   Win_FichaArti.BtnBorrar.Enabled  := .F.
   Win_FichaArti.BtnTipo.Enabled    := .T.
   Win_FichaArti.TxtCodArti.Value   := CardArti_GetCodNew()

   Win_FichaArti.BtnTipo.Enabled        := .F.
   Win_FichaArti.BtnDisa.Enabled        := .F.
   Win_FichaArti.BtnMarca.Enabled       := .T.
   Win_FichaArti.BtnGene.Enabled        := .T.
   Win_FichaArti.TxtDesArti.ReadOnly    := .F.
   Win_FichaArti.TxtCodBarr.ReadOnly    := .F.
   Win_FichaArti.TxtFracciones.ReadOnly := .F.
   Win_FichaArti.TxtIncentivo.ReadOnly  := .F.
   Win_FichaArti.TxtUtilU.ReadOnly      := .F.
   Win_FichaArti.TxtUtilF.ReadOnly      := .F.
   Win_FichaArti.TxtPrecioU.ReadOnly    := .F.
   Win_FichaArti.TxtPrecioF.ReadOnly    := .F.
   Win_FichaArti.TxtDesArti.Value       := SPACE(40)
   Win_FichaArti.TxtFracciones.Value    := 1
   Win_FichaArti.CmbIgv.Value           := 1
   Win_FichaArti.TxtDesArti.SetFocus()

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC CardArti_Consultar

LOCAL aArtiSele

LOCAL qMArti
LOCAL oMArti

   aArtiSele := Ayuda_Arti()
   IF LEN(aArtiSele) > 0

      CardArti_Iniciar()
      KA_MODO := 'ABRIR'
      Win_FichaArti.BtnNuevo.Enabled      := .T.
      Win_FichaArti.BtnEditar.Enabled     := .T.
      Win_FichaArti.BtnGrabar.Enabled     := .F.
      Win_FichaArti.BtnBorrar.Enabled     := .T.

      qMArti := ;
      "SELECT * "+;
      "FROM PRODUCTOS "+;
      "WHERE MA_CODI = '"+aArtiSele[1]+"' "
//      "INNER JOIN MAESTIPO ON MA_TIPO = MI_CODI "+;
//      "LEFT  JOIN CATALOGO ON MA_DISA = CA_CODI "+;
//      "LEFT  JOIN MAESMARK ON MA_MARK = MM_CODI "+;
//      "LEFT  JOIN MAESGENE ON MA_GENE = MG_CODI "+;
      oMArti := oServer:Query( qMArti )
      If oMArti:NetErr()
         MsgStop ( oMArti:Error() )
         Return
      ENDIF
      IF oMArti:LastRec() = 0
         RETURN
      ENDIF
      oRow := oMArti:GetRow(1)

      Win_FichaArti.TxtCodTipo.Value    := oRow:fieldGet("ma_tipo") //oRow:fieldGet("mi_codi")
//      Win_FichaArti.TxtNomTipo.Value    := oRow:fieldGet("mi_nomb")
      Win_FichaArti.TxtCodDisa.Value    := oRow:fieldGet("ma_disa") //NUL2ZERO(oRow:fieldGet("ca_codi"))
//      IF Win_FichaArti.TxtCodDisa.Value > 0
      Win_FichaArti.TxtNomDisa.Value    := space(30) //DisaNombre(oRow:fieldGet("ca_nomb"),oRow:fieldGet("ca_simpl"),oRow:fieldGet("ca_conce"),oRow:fieldGet("ca_fracs"))
//      ENDIF
      Win_FichaArti.TxtCodArti.Value    := oRow:fieldGet("ma_codi")
      Win_FichaArti.TxtDesArti.Value    := oRow:fieldGet("ma_nomb")
      Win_FichaArti.TxtCodMarca.Value   := space(4)  //NUL2SPC(oRow:fieldGet("mm_codi"))
      Win_FichaArti.TxtDesMarca.Value   := space(30) //NUL2SPC(oRow:fieldGet("mm_nomb"))
      Win_FichaArti.TxtCodGene.Value    := space(4)  //NUL2SPC(oRow:fieldGet("mg_codi"))
      Win_FichaArti.TxtDesGene.Value    := space(30) //NUL2SPC(oRow:fieldGet("mg_nomb"))
      Win_FichaArti.TxtCodBarr.Value    := oRow:fieldGet("ma_barr")
      Win_FichaArti.TxtFracciones.Value := oRow:fieldGet("ma_fracs")
      Win_FichaArti.CmbIgv.Value        := IF( oRow:fieldGet("ma_igv") > 0 , 1 , 2 )
      Win_FichaArti.TxtIncentivo.Value  := oRow:fieldGet("ma_incent")
      Win_FichaArti.TxtCostoU.Value     := oRow:fieldGet("ma_coscom")
      Win_FichaArti.TxtCostoF.Value     := ROUND( oRow:fieldGet("ma_coscom") / oRow:fieldGet("ma_fracs") , 2 )
      Win_FichaArti.TxtUtilU.Value      := oRow:fieldGet("ma_utilu")
      Win_FichaArti.TxtUtilF.Value      := oRow:fieldGet("ma_utilf")
      Win_FichaArti.TxtPrecioU.Value    := oRow:fieldGet("ma_precu")
      Win_FichaArti.TxtPrecioF.Value    := oRow:fieldGet("ma_precf")
      Win_FichaArti.TxtStockU.Value     := oRow:fieldGet("ma_stocku")
      Win_FichaArti.TxtStockF.Value     := oRow:fieldGet("ma_stockf")

      IF Win_FichaArti.TxtFracciones.Value > 1
         Win_FichaArti.LblFra.Visible     := .T.
         Win_FichaArti.TxtCostoF.Visible  := .T.
         Win_FichaArti.TxtUtilF.Visible   := .T.
         Win_FichaArti.TxtPrecioF.Visible := .T.
         Win_FichaArti.TxtStockF.Visible  := .T.
      ELSE
         Win_FichaArti.LblFra.Visible     := .F.
         Win_FichaArti.TxtCostoF.Visible  := .F.
         Win_FichaArti.TxtUtilF.Visible   := .F.
         Win_FichaArti.TxtPrecioF.Visible := .F.
         Win_FichaArti.TxtStockF.Visible  := .F.
      ENDIF

   ENDIF

   Win_FichaArti.TxtCodArti.Setfocus

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC CardArti_Editar

   KA_MODO := 'EDITAR'

   Win_FichaArti.BtnNuevo.Enabled      := .T.
   Win_FichaArti.BtnEditar.Enabled     := .F.
   Win_FichaArti.BtnGrabar.Enabled     := .T.
   Win_FichaArti.BtnBorrar.Enabled     := .F.

   Win_FichaArti.BtnTipo.Enabled       := .T.
   Win_FichaArti.BtnDisa.Enabled       := .T.
   Win_FichaArti.BtnMarca.Enabled      := .T.
   Win_FichaArti.BtnGene.Enabled       := .T.

   Win_FichaArti.TxtDesArti.ReadOnly   := .F.
   Win_FichaArti.TxtCodBarr.ReadOnly   := .F.
   Win_FichaArti.TxtFracciones.ReadOnly:= .F.
   Win_FichaArti.CmbIgv.ReadOnly       := .F.
   Win_FichaArti.TxtIncentivo.ReadOnly := .F.
   Win_FichaArti.TxtUtilU.ReadOnly     := .F.
   Win_FichaArti.TxtUtilF.ReadOnly     := .F.
   Win_FichaArti.TxtPrecioU.ReadOnly   := .F.
   Win_FichaArti.TxtPrecioF.ReadOnly   := .F.

   Win_FichaArti.BtnTipo.Setfocus

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC CardArti_SetTipo

LOCAL aDataTipo
/*
   aDataTipo := Ayuda_Tipo()
   IF LEN( aDataTipo ) > 0
      Win_FichaArti.TxtCodTipo.Value := aDataTipo[1]
      Win_FichaArti.TxtNomTipo.Value := aDataTipo[2]
   ENDIF
*/
RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

FUNC CardArti_SetDisa

LOCAL aDataDisa := {}

/*aDataDisa := Ayuda_Disa()

IF LEN( aDataDisa ) > 0
   IF LEN( aDataDisa ) = 5
      Win_FichaArti.TxtCodDisa.Value    := aDataDisa[1]
      Win_FichaArti.TxtNomDisa.Value    := aDataDisa[2]
      Win_FichaArti.TxtFracciones.Value := aDataDisa[3]
      Win_FichaArti.BtnMarca.SetFocus()
   ENDIF
ENDIF
*/
RETURN(aDataDisa)


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC CardArti_SetMark

LOCAL aDataMark

/*   aDataMark := Ayuda_Mark()
   IF LEN( aDataMark ) > 0
      Win_FichaArti.TxtCodMarca.Value := aDataMark[1]
      Win_FichaArti.TxtDesMarca.Value := aDataMark[2]
   ENDIF
   Win_FichaArti.BtnGene.SetFocus()
*/
RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC CardArti_SetGene

LOCAL aDataGene

/*   aDataGene := Ayuda_Gene()
   IF LEN(aDataGene) > 0
      Win_FichaArti.TxtCodGene.Value := aDataGene[1]
      Win_FichaArti.TxtDesGene.Value := aDataGene[2]
   ENDIF
   Win_FichaArti.TxtFracciones.SetFocus()
*/
RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC CardArti_SetFracs

IF Win_FichaArti.TxtFracciones.Value > 1
   Win_FichaArti.LblFra.Visible     := .T.
   Win_FichaArti.TxtCostoF.Visible  := .T.
   Win_FichaArti.TxtUtilF.Enabled   := .T.
   Win_FichaArti.TxtUtilF.Visible   := .T.
   Win_FichaArti.TxtPrecioF.Enabled := .T.
   Win_FichaArti.TxtPrecioF.Visible := .T.
ELSE
   Win_FichaArti.LblFra.Visible     := .F.
   Win_FichaArti.TxtCostoF.Visible  := .F.
   Win_FichaArti.TxtUtilF.Enabled   := .F.
   Win_FichaArti.TxtUtilF.Visible   := .F.
   Win_FichaArti.TxtPrecioF.Enabled := .F.
   Win_FichaArti.TxtPrecioF.Visible := .F.
ENDIF

Win_FichaArti.CmbIGV.SetFocus()

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC CardArti_Grabar

LOCAL qSave
LOCAL oSave

   IF Win_FichaArti.TxtFracciones.Value = 0
      MsgInfo('Las fracciones deben ser mayor a cero.')
      Win_FichaArti.TxtFracciones.Setfocus
      RETURN
   ENDIF

   DO CASE
      CASE KA_MODO = 'EDITAR'
         qSave := ;
         "UPDATE PRODUCTOS SET "+;
         "ma_nomb = '"+ALLTRIM(Win_FichaArti.TxtDesArti.Value)+"', "+;
         "ma_tipo = '"+Win_FichaArti.TxtCodTipo.Value+"', "+;
         "ma_disa =  "+VALSTR(Win_FichaArti.TxtCodDisa.Value)+" , "+;
         "ma_mark = '"+Win_FichaArti.TxtCodMarca.Value+"', "+;
         "ma_gene = '"+Win_FichaArti.TxtCodGene.Value+"', "+;
         "ma_barr = '"+Win_FichaArti.TxtCodBarr.Value+"', "+;
         "ma_fracs = "+VALSTR(Win_FichaArti.TxtFracciones.Value)+", "+;
         "ma_igv = "+IF(Win_FichaArti.CmbIgv.Value=1,VALSTR(SIS_IGV),'0.00')+", "+;
         "ma_incent = "+VALSTR(Win_FichaArti.TxtIncentivo.Value)+", "+;
         "ma_utilu = "+VALSTR(Win_FichaArti.TxtUtilU.Value)+", "+;
         "ma_utilf = "+VALSTR(Win_FichaArti.TxtUtilF.Value)+", "+;
         "ma_precu = "+VALSTR(Win_FichaArti.TxtPrecioU.Value)+", "+;
         "ma_precf = "+VALSTR(Win_FichaArti.TxtPrecioF.Value)+" "+;
         "WHERE ma_codi = '"+Win_FichaArti.TxtCodArti.Value+"' "

         oSave := oServer:Query( qSave )
         If oSave:NetErr()												
            MsgStop ( oSave:Error() )
         else
            oSave:Destroy()
            CardArti_Iniciar()
         Endif
      CASE KA_MODO = 'CREAR'
         cNewCod := CardArti_GetCodNew()
         qSave := ;
         "INSERT INTO PRODUCTOS (ma_codi,ma_nomb,ma_tipo,ma_disa,ma_mark,ma_gene,ma_barr,ma_fracs,ma_igv,ma_incent,ma_utilu,ma_utilf,ma_precu,ma_precf) "+;
         "VALUES ("+;
                 "'"+cNewCod+"', "+;
                 "'"+ALLTRIM(Win_FichaArti.TxtDesArti.Value)+"', "+;
                 "'"+Win_FichaArti.TxtCodTipo.Value+"', "+;
                 " "+VALSTR(Win_FichaArti.TxtCodDisa.Value)+" , "+;
                 "'"+Win_FichaArti.TxtCodMarca.Value+"', "+;
                 "'"+Win_FichaArti.TxtCodGene.Value+"', "+;
                 "'"+Win_FichaArti.TxtCodBarr.Value+"', "+;
                 " "+VALSTR(Win_FichaArti.TxtFracciones.Value)+" , "+;
                 "'"+IF(Win_FichaArti.CmbIgv.Value=1,VALSTR(SIS_IGV),'0.00')+"', "+;
                 " "+VALSTR(Win_FichaArti.TxtIncentivo.Value)+" , "+;
                 " "+VALSTR(Win_FichaArti.TxtUtilU.Value)+" , "+;
                 " "+VALSTR(Win_FichaArti.TxtUtilF.Value)+" , "+;
                 " "+VALSTR(Win_FichaArti.TxtPrecioU.Value)+" , "+;
                 " "+VALSTR(Win_FichaArti.TxtPrecioF.Value)+" "+;
                 ") "

         oSave := oServer:Query( qSave )
         If oSave:NetErr()												
            MsgStop ( oSave:Error() )
         else
            oSave:Destroy()
            CardArti_Iniciar()
         Endif
   ENDCASE

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC CardArti_Borrar

LOCAL oQuery

   IF MsgYesNo(' Esta Usted seguro ?')
      oQuery := oServer:Query( "DELETE FROM PRODUCTOS WHERE COD_ARTI = '" + Win_FichaArti.TxtCodArti.Value + "'" )
      If oQuery:NetErr()												
         MsgStop ( oQuery:Error() )
         Return
      Endif
      oQuery:Destroy()
   ENDIF

RETURN


*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*
* FUNCION    : GETCODART                                                 *
* COMENTARIO : Encuentra un codigo nuevo para un artculo.               *
*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*

FUNC CardArti_GetCodNew

LOCAL cCodigoNuev := '000001'
LOCAL qMArti,oMArti

   qMArti := "SELECT MA_CODI FROM PRODUCTOS ORDER BY MA_CODI DESC LIMIT 1"
	oMArti := oServer:Query( qMArti )
	IF oMArti:NetErr()
		MsgStop ( oMArti:Error() )
		Return('')
   ENDIF
   IF oMArti:LastRec() > 0
      oRow := oMArti:GetRow(1)
      cCodigoNuev := STRZERO( VAL(oRow:fieldGet("ma_codi"))+1 , 6 )
   ENDIF
	oMArti:Destroy()

RETURN(cCodigoNuev)