* ------------------------------------------------------ *
* SISTEMA     : INFO-FARMA                               *
* PRG         : HelpArti.PRG                             *
* CREADO      : 15-12-2005                               *
* ACTUALIZADO : 23-08-2017                               *
* AUTOR       : EDUARDO V. FLORES RIVAS                  *
* COMENTARIOS : PRG PARA SELECCION DE ARTICULOS          *
* ------------------------------------------------------ *

FUNC Ayuda_Arti
PARA aExtraData

IF IsWindowDefined(Win_Ayuda_MArti) = .T.
   MINIMIZE WINDOW Win_Ayuda_MArti
   RESTORE WINDOW Win_Ayuda_MArti
   RETURN
ENDIF

PRIVATE aHlpArtDat  := {}
PRIVATE hfCol := { || if ( This.CellRowIndex/2 == int(This.CellRowIndex/2) , { 0,0,0 }     , { 0,0,0 } ) }
PRIVATE hbCol := { || if ( This.CellRowIndex/2 == int(This.CellRowIndex/2) , Mi_Amarillo   , { 255,255,255 } ) }

IF aExtraData = NIL
   aExtraData := {}
ENDIF

DEFINE WINDOW Win_Ayuda_MArti ;
   AT 0,0 ;
   WIDTH 650 HEIGHT 600 ;
   TITLE 'Artculos'  ;
   MODAL ;
   FONT 'Arial' SIZE 10 ;
   ON INIT HelpMArtiInicia()

   ON KEY F1     ACTION HelpMArtiEnfocaBuscar()
   ON KEY ESCAPE ACTION HelpMArtiCierra()

   @ 10, 10 BUTTON BotBuscar ;
      CAPTION 'Buscar:' ;
      ACTION HelpMArtiEnfocaBuscar() ;
      WIDTH 60 ;
      HEIGHT 20

   @ 10, 80 TEXTBOX TxtBuscar ;
      WIDTH  280 ;
      HEIGHT 20 ;
      UPPERCASE ;
      ON ENTER HelpMArtiBusca()

   @ 40, 10 GRID GrdMArti ;
      WIDTH 620 ;
      HEIGHT 470 ;
      HEADERS {'Cdigo','Artculo','Labo','Stk.U.','Stk.F.'} ;
      WIDTHS  {   60   ,   350    ,  80  ,   60   ,  60    } ;
      JUSTIFY {  BrwL  , BrwL     , BrwL , BrwR   , BrwR   } ;
      BACKCOLOR Mi_Amarillo              ;
      DYNAMICBACKCOLOR { hbCol , hbCol , hbCol , hbCol , hbCol } ;
      DYNAMICFORECOLOR { hfCol , hfCol , hfCol , hfCol , hfCol } ;
      ON DBLCLICK HelpMArtiElige()

   @ 520, 10 BUTTON BotAceptar ;
      CAPTION "Aceptar" ;
      ACTION HelpMArtiElige() ;
      WIDTH 80 ;
      HEIGHT 30

   @ 520, 110 BUTTON BotCancelar ;
      CAPTION "Cancelar" ;
      ACTION HelpMArtiCierra() ;
      WIDTH 80 ;
      HEIGHT 30

END WINDOW

CENTER WINDOW Win_Ayuda_MArti
ACTIVATE WINDOW Win_Ayuda_MArti

RETURN(aHlpArtDat)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

PROC HelpMArtiInicia

   Win_Ayuda_MArti.TxtBuscar.SetFocus

RETURN


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

PROC HelpMArtiCierra

   aHlpArtDat := {}
   RELEASE WINDOW Win_Ayuda_MArti

RETURN


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

PROC HelpMArtiElige

LOCAL aElegido

   IF Win_Ayuda_MArti.GrdMArti.Value > 0
      aElegido :=  Win_Ayuda_MArti.GrdMArti.Item ( Win_Ayuda_MArti.GrdMArti.Value )
      aHlpArtDat := { aElegido[1] , aElegido[2] }
      RELEASE WINDOW Win_Ayuda_MArti
   ENDIF

RETURN


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

PROC HelpMArtiEnfocaBuscar

   Win_Ayuda_MArti.TxtBuscar.Value := SPACE(30)
   Win_Ayuda_MArti.TxtBuscar.SetFocus

RETURN


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

PROC HelpMArtiBusca

LOCAL cBusqueda := Win_Ayuda_MArti.TxtBuscar.Value
LOCAL q        := 1
LOCAL qMArti
LOCAL oMArti

   IF EMPTY(cBusqueda)
      RETURN
   ENDIF

   nApostro := AT("'",cBusqueda)
   IF nApostro > 0
      cBusqueda := STRTRAN( cBusqueda , "'" )
      nEspacio := AT(" ",cBusqueda)
      IF nEspacio > 0
      cBusqueda := LEFT( cBusqueda , nEspacio-1 )
      ENDIF
   ENDIF

   Win_Ayuda_MArti.GrdMArti.DeleteAllItems

   cTipBus := HelpMArtiQueBusco( cBusqueda )
   DO CASE
      CASE cTipBus = 'codigo'
         qMArti := "SELECT * FROM PRODUCTOS WHERE MA_CODI = '"+RTRIM(cBusqueda)+"' "
      CASE cTipBus = 'barra'
         qMArti := "SELECT * FROM PRODUCTOS WHERE MA_BARR = '"+PADR(cBusqueda,20)+"' "
      CASE cTipBus = 'nombre'
         qMArti := "SELECT * FROM PRODUCTOS WHERE MA_NOMB LIKE '"+RTRIM(cBusqueda)+"%' ORDER BY MA_NOMB"
   ENDCASE

	oMArti := oServer:Query( qMArti )
	If oMArti:NetErr()
		MsgStop ( oMArti:Error() )
      Win_Ayuda_MArti.TxtBuscar.Setfocus
		Return
   ENDIF
   For q = 1 To oMArti:LastRec()
      oRow := oMArti:GetRow(q)
      Win_Ayuda_MArti.GrdMArti.AddItem ( {;
         oRow:fieldGet("ma_codi") ,;
         oRow:fieldGet("ma_nomb") ,;
         oRow:fieldGet("ma_mark") ,;
         TRANS( oRow:fieldGet("ma_stocku") , '9999999' ) ,;
         TRANS( oRow:fieldGet("ma_stockf") , '9999999' ) } )
      oMArti:Skip(1)
   Next
	oMArti:Destroy()

   Win_Ayuda_MArti.GrdMArti.value := 1
   Win_Ayuda_MArti.GrdMArti.setfocus

RETURN


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC HelpMArtiQueBusco(cCadena)

LOCAL QueEs  := ''
LOCAL nCount := 0

   cCadena := RTRIM(cCadena)
   IF LEN(cCadena) >= 6
      FOR nCad=1 TO LEN(cCadena)
         IF SUBSTR(cCadena,nCad,1) $ '0123456789'
            nCount++
         ENDIF
      NEXT
   ENDIF
   DO CASE
      CASE LEN(cCadena) = nCount .AND. nCount = 6
         QueEs := 'codigo'
      CASE LEN(cCadena) = nCount .AND. nCount > 6
         QueEs := 'barra'
      OTHERWISE
         QueEs := 'nombre'
   ENDCASE

RETURN( QueEs )